diff --git a/lib/hive/bot/handlers/recovery_sequence.rb b/lib/hive/bot/handlers/recovery_sequence.rb
index b83885cd..b2de9a9d 100644
--- a/lib/hive/bot/handlers/recovery_sequence.rb
+++ b/lib/hive/bot/handlers/recovery_sequence.rb
@@ -180,24 +180,11 @@ module Hive
         # would exit 4. Both branches intentionally diverge from the
         # pre-U7 clear_and_retry path.
         def self.retry_commands(project:, slug:, stage:, marker:, match_attr: nil, workflow: nil)
-          verb = retry_verb_for_stage(stage, workflow: workflow, project: project)
-          return [] unless verb
-
-          commands = []
-          marker_name = marker.to_s
-          unless marker_name.casecmp("none").zero? || marker_name.casecmp("agent_working").zero?
-            clear_argv = [ "hive", "markers", "clear", slug, "--name", marker_name.upcase,
-                           "--project", project ]
-            clear_argv += [ "--match-attr", match_attr ] if match_attr.to_s.include?("=")
-            clear_argv << "--json"
-            commands << clear_argv
-          end
-          # `hive run` (the generic stage runner) scopes by --stage and has no
-          # --from; the coding advance/recovery verbs assert the source stage
-          # with --from.
-          stage_flag = verb == "run" ? "--stage" : "--from"
-          commands << [ "hive", verb, slug, stage_flag, stage, "--project", project, "--json" ]
-          commands
+          require "hive/recovery_sequence"
+          Hive::RecoverySequence.commands(
+            project: project, slug: slug, stage: stage, marker: marker,
+            match_attr: match_attr, workflow: workflow
+          )
         end
 
         def self.alert_reset(project, slug, stage, marker = nil, match_attr = nil)
diff --git a/lib/hive/claude_launcher.rb b/lib/hive/claude_launcher.rb
index 15b092ae..6435af7e 100644
--- a/lib/hive/claude_launcher.rb
+++ b/lib/hive/claude_launcher.rb
@@ -482,13 +482,33 @@ module Hive
       ENV.fetch("HIVE_TMUX_BIN", "tmux")
     end
 
+    def interactive_wrapper_path
+      File.expand_path("scripts/interactive_claude_wrapper.sh", __dir__)
+    end
+
+    # Uses the production readiness detector over shipped, deterministic
+    # samples. Health checks call this API rather than maintaining a second,
+    # weaker String#include? detector that can drift from launch behavior.
+    def readiness_detector_self_check
+      positive = "Claude Code\n❯ \n"
+      negative = "Claude Code\nQuick safety check\nYes, I trust this folder\n❯ \n"
+      positive_ok = claude_ready_prompt?(positive)
+      negative_ok = !claude_ready_prompt?(negative)
+      {
+        ok: positive_ok && negative_ok,
+        detail: positive_ok && negative_ok ? "production_samples_ok" : "production_samples_failed"
+      }
+    rescue StandardError => e
+      { ok: false, detail: e.class.name }
+    end
+
     def wrapper_command(cwd:, add_dirs:, profile:, permission_mode:,
                         allowed_tools: DEFAULT_ALLOWED_TOOLS,
                         disallowed_tools: nil, cli_flags: [],
                         mcp_config_path: nil, strict_mcp_config: false)
       command = [
         "bash",
-        File.expand_path("scripts/interactive_claude_wrapper.sh", __dir__),
+        interactive_wrapper_path,
         "--cwd", cwd
       ]
       Array(add_dirs).each { |dir| command.concat([ "--add-dir", dir ]) }
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd809068..74e62237 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -46,7 +46,12 @@ module Hive
 
     desc "version", "Print hive version"
     def version
-      puts Hive::VERSION
+      if options[:json]
+        require "hive/runtime_identity"
+        puts JSON.generate(Hive::RuntimeIdentity.snapshot)
+      else
+        puts Hive::VERSION
+      end
     end
     map "--version" => :version
 
@@ -977,16 +982,19 @@ module Hive
     option :project, type: :string, desc: "scope slug lookup to one registered project"
     option :match_attr, type: :string,
                         desc: "refuse clear unless marker has attr(s): KEY=VALUE[,KEY=VALUE]"
+    option :recovery_id, type: :string,
+                         desc: "internal auto-retry recovery id (daemon only; skips manual rearm)"
     def markers(subcommand, target = nil)
       require "hive/commands/markers"
-      Hive::Commands::Markers.new(
-        subcommand,
-        target,
+      kwargs = {
         name: options[:name],
         project: options[:project],
         match_attr: options[:match_attr],
         json: options[:json]
-      ).call
+      }
+      recovery_id = options[:recovery_id]
+      kwargs[:recovery_id] = recovery_id unless recovery_id.nil?
+      Hive::Commands::Markers.new(subcommand, target, **kwargs).call
     end
 
     desc "babysit SUBCOMMAND [PROJECT]", "Manage the experimental PR babysitter"
diff --git a/lib/hive/commands/doctor.rb b/lib/hive/commands/doctor.rb
index 99afbc08..dc2203be 100644
--- a/lib/hive/commands/doctor.rb
+++ b/lib/hive/commands/doctor.rb
@@ -45,6 +45,16 @@ module Hive
       # JSON encoder. Returns `nil` before `#call` has populated it.
       attr_reader :rows
 
+      # Lightweight in-process API shared by the CLI and daemon health gate.
+      # It deliberately omits optional qmd/migration warnings and accepts
+      # already-bounded dependency rows so daemon callers never shell out
+      # through Doctor's human-oriented probes.
+      def self.required_agent_rows(config:, project_root:, dependency_rows: nil)
+        new(config: config, project_root: project_root).required_agent_rows(
+          dependency_rows: dependency_rows
+        )
+      end
+
       def initialize(config:, project_root:, json: false, output: $stdout)
         @config = config
         @project_root = project_root
@@ -71,6 +81,11 @@ module Hive
         EXIT_CONFIG_ERROR
       end
 
+      def required_agent_rows(dependency_rows: nil)
+        dependencies = dependency_rows.nil? ? check_tmux : Array(dependency_rows)
+        dependencies + check_stages + check_reviewers
+      end
+
       private
 
       def failing_status?(status)
diff --git a/lib/hive/commands/markers.rb b/lib/hive/commands/markers.rb
index f5df7df1..50928476 100644
--- a/lib/hive/commands/markers.rb
+++ b/lib/hive/commands/markers.rb
@@ -42,13 +42,22 @@ module Hive
 
       VALID_SUBCOMMANDS = %w[clear].freeze
 
-      def initialize(subcommand, target = nil, name: nil, project: nil, match_attr: nil, json: false)
+      # Lightweight row shape for reusing AutoRetry::Safety without depending
+      # on StatusConsumer during an in-process clear.
+      SafetyRow = Struct.new(:project, :slug, :stage, :folder, :state_file, :marker,
+                             :marker_attrs, :live_task_lock, :worktree_path, :id,
+                             :task_lock_owned,
+                             keyword_init: true)
+
+      def initialize(subcommand, target = nil, name: nil, project: nil, match_attr: nil, json: false,
+                     recovery_id: nil)
         @subcommand = subcommand
         @target = target
         @name = name
         @project_filter = project
         @match_attr = match_attr
         @json = json
+        @recovery_id = recovery_id
       end
 
       def call
@@ -104,19 +113,31 @@ module Hive
         # erases that fresh marker. The hive_commit follows under
         # `with_commit_lock` to serialise hive/state branch writes
         # against any concurrent committer (auto-heal, run loop).
-        Hive::Markers.with_markers_lock(task.state_file) do
-          marker = Hive::Markers.current(task.state_file)
-          actual = marker.name.to_s.upcase
-          unless actual == normalized
-            raise Hive::WrongStage,
-                  "hive markers clear: task #{task.slug} has marker #{actual.inspect}, " \
-                  "not #{normalized.inspect}; refusing to clear (the file may have been edited)."
+        cleared_attrs = nil
+        with_auto_retry_task_lock(task) do |task_lock_owned|
+          Hive::Markers.with_markers_lock(task.state_file) do
+            marker = Hive::Markers.current(task.state_file)
+            actual = marker.name.to_s.upcase
+            unless actual == normalized
+              raise Hive::WrongStage,
+                    "hive markers clear: task #{task.slug} has marker #{actual.inspect}, " \
+                    "not #{normalized.inspect}; refusing to clear (the file may have been edited)."
+            end
+
+            match_attr_or_raise!(task, marker)
+            auto_retry_safety_or_raise!(task, marker, task_lock_owned: task_lock_owned) if auto_retry_clear?
+            cleared_attrs = marker.attrs.dup
+            # Durable retry accounting is a write-ahead transition. If it
+            # cannot be persisted, the marker remains intact and the command
+            # fails closed. Reconciliation tolerates the opposite crash window
+            # (ledger advanced but marker removal not yet committed).
+            persist_auto_retry_ledger!(task, cleared_attrs)
+            Hive::Markers.remove_marker(task.state_file, marker.raw)
           end
-
-          match_attr_or_raise!(task, marker)
-          Hive::Markers.remove_marker(task.state_file, marker.raw)
         end
 
+        emit_manual_clear_audit(task, cleared_attrs) unless auto_retry_clear?
+
         Hive::Lock.with_commit_lock(task.hive_state_path) do
           record_hive_commit(task, normalized)
         end
@@ -124,6 +145,122 @@ module Hive
         emit_success(task, normalized)
       end
 
+      def auto_retry_clear?
+        !@recovery_id.nil? && !@recovery_id.to_s.strip.empty?
+      end
+
+      # Automatic clear: re-run stage safety under current on-disk state and
+      # require the durable intent to carry this recovery_id. Never rearms.
+      def auto_retry_safety_or_raise!(task, marker, task_lock_owned:)
+        require "hive/daemon/auto_retry/state"
+        require "hive/daemon/auto_retry/safety"
+
+        reason = marker.attrs["reason"].to_s
+        marker_id = marker.attrs["marker_id"].to_s
+        unless Hive::Config.load_global_daemon.dig("auto_retry", "enabled") != false
+          raise Hive::WrongStage,
+                "hive markers clear: daemon.auto_retry.enabled is false; refusing automatic clear"
+        end
+        state = Hive::Daemon::AutoRetry::State.new
+        task_key = Hive::Daemon::AutoRetry::State.task_key(task_id: task.id, slug: task.slug)
+        record = state.get(
+          project: project_name_for(task),
+          task_key: task_key,
+          stage: "#{task.stage_index}-#{task.stage_name}",
+          reason: reason
+        )
+        unless record.is_a?(Hash) && record["recovery_id"].to_s == @recovery_id.to_s &&
+               %w[clear_queued marker_cleared].include?(record["phase"].to_s)
+          raise Hive::WrongStage,
+                "hive markers clear: recovery_id #{@recovery_id.inspect} does not match " \
+                "a durable auto-retry intent; refusing automatic clear"
+        end
+
+        row = SafetyRow.new(
+          project: project_name_for(task),
+          slug: task.slug,
+          stage: "#{task.stage_index}-#{task.stage_name}",
+          folder: task.folder,
+          state_file: task.state_file,
+          marker: marker.name.to_s,
+          marker_attrs: marker.attrs,
+          live_task_lock: task_lock_owned,
+          task_lock_owned: task_lock_owned,
+          worktree_path: (task.worktree_path rescue nil),
+          id: task.id
+        )
+        gate = Hive::Daemon::AutoRetry::Safety.new.check(
+          row: row,
+          observed_marker_id: marker_id,
+          observed_reason: reason,
+          re_read: true
+        )
+        return if gate.safe?
+
+        raise Hive::WrongStage,
+              "hive markers clear: auto-retry safety failed (#{gate.rationale}); " \
+              "refusing to clear"
+      end
+
+      def persist_auto_retry_ledger!(task, cleared_attrs)
+        require "hive/daemon/auto_retry/state"
+        reason = (cleared_attrs || {})["reason"].to_s
+        return if reason.empty?
+
+        state = Hive::Daemon::AutoRetry::State.new
+        task_key = Hive::Daemon::AutoRetry::State.task_key(task_id: task.id, slug: task.slug)
+        project = project_name_for(task)
+        stage = "#{task.stage_index}-#{task.stage_name}"
+
+        if auto_retry_clear?
+          # Advance phase without resetting attempt budget.
+          state.upsert!(
+            project: project, task_key: task_key, stage: stage, reason: reason,
+            phase: "marker_cleared"
+          )
+        else
+          # Successful manual clear rearms the two-attempt budget.
+          state.rearm_manual!(
+            project: project, task_key: task_key, stage: stage, reason: reason
+          )
+        end
+      end
+
+      def with_auto_retry_task_lock(task)
+        return yield(false) unless auto_retry_clear?
+
+        Hive::Lock.with_task_lock(
+          task.folder,
+          "op" => "auto_retry_clear",
+          "recovery_id" => @recovery_id.to_s
+        ) { yield(true) }
+      end
+
+      def emit_manual_clear_audit(task, cleared_attrs)
+        require "hive/events"
+        reason = (cleared_attrs || {})["reason"].to_s
+        return if reason.empty?
+
+        Hive::Events.emit(
+          task_folder: task.folder,
+          slug: task.slug,
+          stage: "#{task.stage_index}-#{task.stage_name}",
+          event_type: :auto_retry_decision,
+          agent: "operator",
+          message: "manual_rearm:manual_clear",
+          details: {
+            action: "manual_rearm", rationale: "manual_clear",
+            marker_reason: reason, marker_id: (cleared_attrs || {})["marker_id"],
+            attempts_rearmed: 2
+          }
+        )
+      end
+
+      def project_name_for(task)
+        match = Hive::Config.registered_projects.find { |p| p["path"] == task.project_root }
+        match ? match["name"] : File.basename(task.project_root)
+      end
+
       # Cross-process race guard. The TUI observes an ERROR marker at
       # time T and dispatches `hive markers clear` at T+1s. If a
       # concurrent `hive run` writes a fresh ERROR marker in that
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index c686876b..27fdddae 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -313,6 +313,11 @@ module Hive
       "daemon" => {
         "enabled" => false,
         "autostart" => false,
+        # Global kill switch for the v1 health-gated auto-retry coordinator.
+        # Defaults on; does not change per-project daemon.enabled or healer.
+        "auto_retry" => {
+          "enabled" => true
+        },
         "poll_interval_sec" => 30,
         "fast_poll_sec" => 1,
         "edit_debounce_sec" => 30,
@@ -2237,6 +2242,25 @@ module Hive
       end
 
       validate_daemon_verb_timeouts!(daemon, source_path)
+      validate_daemon_auto_retry!(daemon, source_path)
+    end
+
+    def validate_daemon_auto_retry!(daemon, source_path)
+      auto_retry = daemon["auto_retry"]
+      return if auto_retry.nil?
+
+      unless auto_retry.is_a?(Hash)
+        raise ConfigError,
+              "daemon.auto_retry in #{describe_source(source_path)} must be a Hash; " \
+              "got #{auto_retry.inspect} (#{auto_retry.class})"
+      end
+
+      enabled = auto_retry["enabled"]
+      return if enabled.nil? || enabled == true || enabled == false
+
+      raise ConfigError,
+            "daemon.auto_retry.enabled in #{describe_source(source_path)} must be a boolean " \
+            "(true / false); got #{enabled.inspect} (#{enabled.class})"
     end
 
     def validate_web_config!(cfg, source_path)
diff --git a/lib/hive/daemon/auto_retry/classifier.rb b/lib/hive/daemon/auto_retry/classifier.rb
new file mode 100644
index 00000000..8b308405
--- /dev/null
+++ b/lib/hive/daemon/auto_retry/classifier.rb
@@ -0,0 +1,356 @@
+# frozen_string_literal: true
+
+require "hive/task_action"
+require "hive/stages/base"
+require "hive/config"
+
+module Hive
+  module Daemon
+    module AutoRetry
+      # Pure fail-closed classifier for v1 health-gated auto-retry.
+      # Maps a terminal ERROR row into one of:
+      #   - :codex_auth_401
+      #   - :claude_launcher
+      #   - :ineligible
+      # without launching probes or reading the network. Diagnostic text is
+      # evidence only; it never becomes command construction input.
+      class Classifier
+        RECOVERY_CODEX_AUTH = :codex_auth_401
+        RECOVERY_CLAUDE_LAUNCHER = :claude_launcher
+        RECOVERY_INELIGIBLE = :ineligible
+
+        # Exact Codex 401 authentication signature. Require HTTP 401 plus
+        # either missing-bearer or basic-auth wording so an unrelated 401
+        # (or a 401 without auth-scheme language) stays parked.
+        CODEX_AUTH_HTTP = /\b(?:http(?:\/\d(?:\.\d)?)?[\s:-]*|status(?:\s+code)?[\s:=]*)401\b/i
+        CODEX_AUTH_BEARER = /missing\s+(?:a\s+)?bearer(?:[-\s]?auth(?:entication|orization)?)?|
+                             no\s+bearer(?:[-\s]?token)?|
+                             bearer\s+(?:token\s+)?(?:missing|required|not\s+found)|
+                             authorization\s+header\s+is\s+missing/ix
+        CODEX_AUTH_BASIC = /basic[-\s]?auth(?:entication|orization)?|
+                            missing\s+(?:a\s+)?basic(?:[-\s]?auth)?|
+                            www-authenticate:\s*basic/ix
+
+        # Claude launcher/packaging/readiness signatures accepted for v1.
+        # Session-name collisions, quota walls, and permission prompts are
+        # excluded so those failures remain manual.
+        CLAUDE_LAUNCHER_SIGNATURES = [
+          /claude interactive prompt did not become ready/i,
+          /could not inspect claude tmux session/i,
+          /tmux session .+ did not start/i,
+          /wrapper\s+(?:script\s+)?(?:missing|not\s+found|not\s+executable|failed)/i,
+          /readiness\s+(?:detector|check|probe)\s+(?:failed|error|mismatch)/i,
+          /packag(?:e|ing).*(?:wrapper|script|install)|(?:wrapper|script|install).*packag(?:e|ing)/i
+        ].freeze
+
+        CLAUDE_EXCLUSIONS = [
+          /already exists/i,
+          /limits?\s+reached|usage[\/\s-]?credit|quota|rate[-\s]?limit|stop and wait for limit/i,
+          /permission(?:s)?\s+(?:prompt|denied|required)|dangerously-skip-permissions/i
+        ].freeze
+
+        Result = Struct.new(
+          :recovery_class,
+          :rationale,
+          :marker_reason,
+          :marker_id,
+          :stage,
+          :evidence_kind,
+          keyword_init: true
+        ) do
+          def eligible?
+            recovery_class != RECOVERY_INELIGIBLE
+          end
+        end
+
+        # @param row [StatusConsumer::Row, Hash, #to_h] status row
+        # @param config [Hash, nil] effective project config
+        # @param evidence [Hash, nil] machine-oriented evidence:
+        #   :text / "text", :kind / "kind", :fresh (bool),
+        #   :marker_signature_match (bool), :error (symbol/string)
+        # @param stage_agent [String, Symbol, nil] override for stage agent
+        # @param execute_agent [String, Symbol, nil] override for execute agent
+        # @param claude_mode [String, Symbol, nil] override for claude.mode
+        def self.classify(row:, config: nil, evidence: nil,
+                          stage_agent: nil, execute_agent: nil, claude_mode: nil)
+          new(
+            row: row,
+            config: config,
+            evidence: evidence,
+            stage_agent: stage_agent,
+            execute_agent: execute_agent,
+            claude_mode: claude_mode
+          ).classify
+        end
+
+        def initialize(row:, config: nil, evidence: nil,
+                       stage_agent: nil, execute_agent: nil, claude_mode: nil)
+          @row = normalize_row(row)
+          @config = config.is_a?(Hash) ? config : {}
+          @evidence = normalize_evidence(evidence)
+          @stage_agent_override = stage_agent
+          @execute_agent_override = execute_agent
+          @claude_mode_override = claude_mode
+        end
+
+        def classify
+          marker_name = marker_name_of
+          reason = marker_reason_of
+          stage = stage_of
+
+          unless marker_name == "error"
+            return ineligible(:not_error_marker)
+          end
+
+          case reason
+          when "implementer_failed"
+            classify_codex_auth(stage)
+          when "claude_launch_failed"
+            classify_claude_launcher(stage)
+          when nil, ""
+            ineligible(:missing_reason)
+          else
+            ineligible(:unknown_reason)
+          end
+        rescue StandardError
+          # Fail closed: a classifier bug must never make a marker eligible.
+          ineligible(:classifier_error)
+        end
+
+        private
+
+        def classify_codex_auth(stage)
+          unless stage == "4-execute" # coding-scoped: v1 Codex recovery is execute-only
+            return ineligible(:wrong_stage)
+          end
+
+          agent = effective_execute_agent
+          unless agent == "codex"
+            return ineligible(:wrong_provider)
+          end
+
+          text = evidence_text
+          if text.nil?
+            return ineligible(evidence_rejection_rationale)
+          end
+
+          unless codex_auth_signature?(text)
+            return ineligible(:unknown_signature)
+          end
+
+          eligible(RECOVERY_CODEX_AUTH, :codex_auth_401)
+        end
+
+        def classify_claude_launcher(stage)
+          agent = effective_stage_agent
+          unless agent == "claude"
+            return ineligible(:wrong_provider)
+          end
+
+          mode = effective_claude_mode
+          unless mode.to_s == "tmux"
+            return ineligible(:wrong_claude_mode)
+          end
+
+          # v1 only defines replay safety for execute + brainstorm/plan.
+          unless %w[2-brainstorm 3-plan 4-execute].include?(stage) # coding-scoped: v1 replay proofs
+            return ineligible(:stage_not_supported)
+          end
+
+          text = evidence_text
+          if text.nil?
+            return ineligible(evidence_rejection_rationale)
+          end
+
+          if claude_excluded?(text)
+            return ineligible(:excluded_signature)
+          end
+
+          unless claude_launcher_signature?(text)
+            return ineligible(:unknown_signature)
+          end
+
+          eligible(RECOVERY_CLAUDE_LAUNCHER, :claude_launcher)
+        end
+
+        def codex_auth_signature?(text)
+          return false unless text.match?(CODEX_AUTH_HTTP)
+
+          text.match?(CODEX_AUTH_BEARER) || text.match?(CODEX_AUTH_BASIC)
+        end
+
+        def claude_launcher_signature?(text)
+          CLAUDE_LAUNCHER_SIGNATURES.any? { |re| text.match?(re) }
+        end
+
+        def claude_excluded?(text)
+          CLAUDE_EXCLUSIONS.any? { |re| text.match?(re) }
+        end
+
+        def evidence_text
+          return nil if @evidence[:error]
+          return nil if @evidence.key?(:fresh) && @evidence[:fresh] == false
+          return nil if @evidence.key?(:marker_signature_match) &&
+                        @evidence[:marker_signature_match] == false
+
+          text = @evidence[:text].to_s
+          marker_msg = marker_message
+          parts = [ marker_msg, text ].map { |p| p.to_s.strip }.reject(&:empty?)
+          return nil if parts.empty?
+
+          parts.join("\n")
+        end
+
+        def evidence_rejection_rationale
+          case @evidence[:error].to_s
+          when "stale_diagnostic" then return :stale_diagnostic
+          when "missing_diagnostic", "missing_folder" then return :missing_diagnostic
+          when "unreadable_diagnostic" then return :unreadable_diagnostic
+          when "" then # fall through
+          else
+            return :evidence_error if @evidence[:error]
+          end
+          return :stale_diagnostic if @evidence.key?(:fresh) && @evidence[:fresh] == false
+          return :stale_diagnostic if @evidence.key?(:marker_signature_match) &&
+                                      @evidence[:marker_signature_match] == false
+          return :missing_diagnostic if @evidence[:text].to_s.strip.empty? &&
+                                        marker_message.strip.empty?
+
+          :missing_diagnostic
+        end
+
+        def marker_message
+          attrs = marker_attrs
+          attrs["message"].to_s
+        end
+
+        def effective_execute_agent
+          return @execute_agent_override.to_s.downcase if @execute_agent_override
+
+          begin
+            Hive::Stages::Base.stage_profile(@config, "execute").name.to_s.downcase
+          rescue StandardError
+            (@config.dig("execute", "agent") || "claude").to_s.downcase
+          end
+        end
+
+        def effective_stage_agent
+          return @stage_agent_override.to_s.downcase if @stage_agent_override
+
+          stage_name = stage_role_name
+          begin
+            Hive::Stages::Base.stage_profile(@config, stage_name).name.to_s.downcase
+          rescue StandardError
+            (@config.dig(stage_name, "agent") || "claude").to_s.downcase
+          end
+        end
+
+        def effective_claude_mode
+          return @claude_mode_override.to_s if @claude_mode_override
+
+          begin
+            Hive::Config.claude_mode(@config).to_s
+          rescue StandardError
+            (@config.dig("claude", "mode") || "tmux").to_s
+          end
+        end
+
+        def stage_role_name
+          # coding-scoped (block): maps coding descriptor dirs to config role names
+          case stage_of
+          when "2-brainstorm" then "brainstorm"
+          when "3-plan" then "plan"
+          when "4-execute" then "execute"
+          when "5-open-pr" then "open_pr"
+          when "7-artifacts" then "artifacts"
+          when "8-finalize" then "finalize"
+          else
+            stage_of.to_s.sub(/\A\d+-/, "").tr("-", "_")
+          end
+        end
+
+        def marker_name_of
+          raw = @row[:marker]
+          raw = raw.name if raw.respond_to?(:name) && !raw.is_a?(String)
+          raw.to_s.downcase
+        end
+
+        def marker_reason_of
+          attrs = marker_attrs
+          attrs["reason"].to_s
+        end
+
+        def marker_id_of
+          marker_attrs["marker_id"].to_s
+        end
+
+        def marker_attrs
+          attrs = @row[:marker_attrs] || @row[:attrs] || {}
+          return {} unless attrs.is_a?(Hash)
+
+          attrs.each_with_object({}) do |(k, v), acc|
+            acc[k.to_s] = v
+          end
+        end
+
+        def stage_of
+          @row[:stage].to_s
+        end
+
+        def normalize_row(row)
+          return row if row.is_a?(Hash) && (row.key?(:marker) || row.key?("marker"))
+
+          if row.respond_to?(:to_h)
+            h = row.to_h
+            return h.transform_keys(&:to_sym) if h.is_a?(Hash)
+          end
+
+          {
+            marker: row.respond_to?(:marker) ? row.marker : nil,
+            marker_attrs: row.respond_to?(:marker_attrs) ? row.marker_attrs : {},
+            stage: row.respond_to?(:stage) ? row.stage : nil,
+            folder: row.respond_to?(:folder) ? row.folder : nil,
+            project: row.respond_to?(:project) ? row.project : nil,
+            slug: row.respond_to?(:slug) ? row.slug : nil
+          }
+        rescue StandardError
+          {}
+        end
+
+        def normalize_evidence(evidence)
+          return {} if evidence.nil?
+          return evidence.transform_keys(&:to_sym) if evidence.is_a?(Hash)
+
+          if evidence.respond_to?(:to_h)
+            h = evidence.to_h
+            return h.transform_keys(&:to_sym) if h.is_a?(Hash)
+          end
+
+          { text: evidence.to_s, kind: :raw }
+        end
+
+        def eligible(recovery_class, rationale)
+          Result.new(
+            recovery_class: recovery_class,
+            rationale: rationale.to_s,
+            marker_reason: marker_reason_of,
+            marker_id: marker_id_of,
+            stage: stage_of,
+            evidence_kind: @evidence[:kind]
+          )
+        end
+
+        def ineligible(rationale)
+          Result.new(
+            recovery_class: RECOVERY_INELIGIBLE,
+            rationale: rationale.to_s,
+            marker_reason: marker_reason_of,
+            marker_id: marker_id_of,
+            stage: stage_of,
+            evidence_kind: @evidence[:kind]
+          )
+        end
+      end
+    end
+  end
+end
